import Animated from 'react-native-reanimated';
import type { LayoutChangeEvent } from 'react-native';
/**
  * Namespace for animated values associated with the scrolling content.
  */
declare class AnimatedStoreScrolling {
    static _scrollingClock: Animated.Clock;
    static _scrollY: Animated.Value<number>;
    static _velocityScrollY: Animated.Value<number>;
    static _panScrollState: Animated.Value<number>;
    static _onGestureEventScrolling: (...args: any[]) => void;
    static enabledContentGestureInteraction: boolean;
    static contentHeight: Animated.Value<number>;
    static headerHeight: number;
    static snapPoints: readonly number[];
    static init: (enabledContentGestureInteraction: boolean, snapPoints: readonly number[]) => void;
    static handleLayoutHeader: ({ nativeEvent: { layout: { height: heightOfHeader }, }, }: LayoutChangeEvent) => void;
    static handleLayoutContent: ({ nativeEvent: { layout: { height }, }, }: LayoutChangeEvent) => void;
    static limitedScroll: (val: Animated.Value<number>) => Animated.Node<number>;
    static _prevTransY: Animated.Value<number>;
    static _transY: Animated.Value<number>;
    static _startedAtTheTop: Animated.Value<number>;
    /**
     * 1 - scrolling content
     * 2 - sheet dragging
     */
    static _lastState: Animated.Value<number>;
    static scrollOffset: Animated.Value<number>;
    static scrollOffsetWhileSnapped: Animated.Value<number>;
    static _masterScrollY: Animated.Node<number>;
}
export { AnimatedStoreScrolling };
